@echo off
:: --------------------------------------------------------------------
:: (C) Copyright 1990-1995 by Autodesk, Inc.
:: Permission to use, copy, modify, and distribute this software and its
:: documentation for any purpose and without fee is hereby granted.
:: THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
:: ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
:: MERCHANTABILITY ARE HEREBY DISCLAIMED.
:: --------------------------------------------------------------------
::
::             ARX environment setup for nmake
::
:: Batch file to set up environment for building ARX programs with
:: 32-bit edition MSVC++ for Windows and Windows NT. This batch file
:: requires NMAKE and the make file SproEval.MAK.
::
:: The name of source file (without extension) must be supplied as first
:: parameter to batch file. The SproEval.MAK make file expects the file
:: extension to be .CPP not .CC. If you want to use .CC then you must
:: change the "EXT" macro at the beginning of the MKEVAL15.MAK file.


if (%1) == () goto noname

:: set variable for name of source file (without extension)
set INFILE=%1

:: save off old path
set OLDPATH=%PATH%

:: set variable for the location of root of the ARX subdirectory tree
set ARXPATH=d:\arx

:: set variable for location of ADS include files
set ADSINC=d:\arx\inc

:: set variable for location of ARX include files
set ACRXINC=%arxpath%\inc

:: set variable for location of ARX library files
set ACRXLIB=%arxpath%\lib

:: append path of ARX include files in INCLUDE env variable
set INCLUDE=%INCLUDE%;%ADSINC%;%acrxinc%

:: append path of ARX lib files in LIB env variable
set LIB=%LIB%;%acrxlib%
:: Call vsvars32.bat to set path for MSVC environment

call "D:\Program Files\Microsoft Visual Studio\VC98\Bin\vcvars32" x86


nmake -f sproARX.mak CFG="sproARX - Win32 Release"


:: restore old path
set PATH= %OLDPATH%

:: clean up environment space
set INFILE=
set OLDPATH=
set MSVCPATH=
set ARXPATH=
set ADSINC=
set ACRXINC=
set ACRXLIB=
set MDRV=
set ADRV=
:: Uncomment the following if you don't want INCLUDE and LIB set
:: set INCLUDE=
:: set LIB=

goto end

:noname
echo syntax is
echo Build SproARX (filename with no extension)

:end
