;********************************************************************************************************
;(C) Copyright 1986-2002. Rainbow Technologies, Inc. All rights reserved.
;
; Sentinel SuperPro Evaluation Program for AutoLisp with ARX applications
;
; BEFORE RUNNING THIS APPLICATION , YOU MUST SET UP THE PATH TO SPROEVAL.ARX
; FOR THE TWO AUTOLISP FUNCTIONS ARXLOAD AND ARXUNLOAD.
;
; See the file API.DOC for a complete discription of the Sentinel SuperPro
; function calls available.  Described here briefly, are function calls to
; ARX applications, such as SPROEVAL.ARX. Inside the ARX application,
; the true call to the Sentinel SuperPro code takes place.
;********************************************************************************************************

;Define some variables required
	( setq value 0)
	( setq intvalue 0)
	(setq SP_SUCCESS 0)
	(setq SP_ACCESS_DENIED 4)
	(setq TRUE 1)                         ;Preset some global expressions
	(setq FALSE 0)
	(setq WritePassword "0000")
	(setq OverwritePassword1 "0000")
	(setq OverwritePassword2 "0000")
	(setq developer_id "0000")
	(setq horz (chr 85))
	(setq vert (chr 124))


(defun readHexData (string length) 
        
		( setq value 0)
    ( setq  i 1 )
    ( setq  hexToDec 0)
    ( setq thisString "")
		( setq thisString string )
			
  	( if (> (strlen thisString) length)
			( setq value 0)    
				(progn	 
					(while (<= i (strlen thisString)) 
						( if (or (= (ascii (substr thisString (eval i ) 1)) 65) (= (ascii (substr thisString (eval i ) 1)) 66) (= (ascii (substr thisString (eval i ) 1)) 67) 
						(= (ascii (substr thisString (eval i ) 1)) 68) (= (ascii (substr thisString (eval i ) 1)) 69) (= (ascii (substr thisString (eval i ) 1)) 70 )
						(= (ascii (substr thisString (eval i ) 1)) 97) (= (ascii (substr thisString (eval i ) 1)) 98) (= (ascii (substr thisString (eval i ) 1)) 99) 
						(= (ascii (substr thisString (eval i ) 1)) 100) (= (ascii (substr thisString (eval i ) 1)) 101) (= (ascii (substr thisString (eval i ) 1)) 102 )
						(= (ascii (substr thisString (eval i ) 1)) 48) (= (ascii (substr thisString (eval i ) 1)) 49) (= (ascii (substr thisString (eval i ) 1)) 50) 
						(= (ascii (substr thisString (eval i ) 1)) 51) (= (ascii (substr thisString (eval i ) 1)) 52) (= (ascii (substr thisString (eval i ) 1)) 53 )
						(= (ascii (substr thisString (eval i ) 1)) 54) (= (ascii (substr thisString (eval i ) 1)) 55) (= (ascii (substr thisString (eval i ) 1)) 56) 
						(= (ascii (substr thisString (eval i ) 1)) 57) (= (ascii (substr thisString (eval i ) 1)) 0) )
							(setq hexToDec (1+ hexToDec))
						 )
						(setq i (1+ i))
						( if (= hexToDec (strlen thisString))

							( setq value 1)
							( setq value 0)
						)
					)
				)
			)
  )

(defun IsInt (string length) 
        
		
		( setq intvalue 0)
    ( setq  i 1 )
    ( setq  int 0)
    ( setq thisString "")
		( setq thisString string )
			
  	( if (> (strlen thisString) length)
			( setq value 0)    
				(progn	 
					(while (<= i (strlen thisString)) 
					
						( if (or(= (ascii (substr thisString (eval i ) 1)) 48) (= (ascii (substr thisString (eval i ) 1)) 49) (= (ascii (substr thisString (eval i ) 1)) 50) 
						(= (ascii (substr thisString (eval i ) 1)) 51) (= (ascii (substr thisString (eval i ) 1)) 52) (= (ascii (substr thisString (eval i ) 1)) 53 )
						(= (ascii (substr thisString (eval i ) 1)) 54) (= (ascii (substr thisString (eval i ) 1)) 55) (= (ascii (substr thisString (eval i ) 1)) 56) 
						(= (ascii (substr thisString (eval i ) 1)) 57))
							(setq int (1+ int))
						 )
						(setq i (1+ i))
						( if (= int (strlen thisString))

							( setq intvalue 1)
							( setq intvalue 0)
						)
					)
				)
			)
  )




;********************************************************************************************************
; FormatPacket	- This function calls sproFormatPacket function of SPROEVAL.ARX to format an API packet.
; INPUT					- None.
; OUTPUT				- nth 0 is the API rerurn code.
; DESCRIPTION		- To Call RNBOsproInitialize API. Format the API Packet.
;********************************************************************************************************
(defun  FormatPacket()

	(setq result_list (sproFormatPacket))
	;(write-line "before result")
	;(write-line result_list )
	;(write-line "afretbefore result")
	(setq status (nth 0 result_list))
	(if (/= status SP_SUCCESS)
		(progn
			(write-line (strcat "FormatPacket failed! Return code is " (itoa status) "."))
		)
		(write-line "FormatPacket successful!")
	)
)


;********************************************************************************************************
; Initialize			- This function calls sproInitialize function of SPROEVAL.ARX to initilize an API packet. 
; INPUT					- None.
; OUTPUT				- nth 0 is the API rerurn code.
; DESCRIPTION		- To Call RNBOsproInitialize API. Initialize the API Packet.
;********************************************************************************************************
(defun  Initialize()
	(setq result_list (sproInitialize))  ; call to API function to 
	(setq status (nth 0 result_list))
	(if (/= status SP_SUCCESS)
		(write-line (strcat "Initialize failed! Return code is " (itoa status) "."))
		;; ELSE
		(write-line "Initialize successful!")
	)
)


;********************************************************************************************************
; SetProtocol		- This function calls sproSetProtocol of SPROEVAL.ARX to set protocol for client server 
;								- communication.
; INPUT					- protocolFlag(NSPRO_TCP_PROTOCOL-1, NSPRO_IPX_PROTOCOL, NSPRO_NETBEUI_PROTOCOL-4, 
;								- NSPRO_SAP_PROTOCOL-8.
; OUTPUT				- nth 0 is the API rerurn code.
; DESCRIPTION   - To call  RNBOsproSetProtocol API.   
;********************************************************************************************************
(defun  SetProtocol()
	(setq pFlag (getstring "Enter ProtocolFlag(1=TCP/IP, 2=IPX/SPX, 4=NetBEUI, 8=SAP) : "))  
	( if (= pFlag "" )
		(write-line "specify protocolflag value to proceed.")
	;; ELSE
		(progn     
			(if (or(= pFlag "1") (=  pFlag "2")(=  pFlag "4") (= pFlag "8"))
				
				(progn
					(setq result_list (sproSetProtocol pFlag))  ; call to API function to establish
					(setq status (nth 0 result_list))
					(if (/= status SP_SUCCESS)
						(write-line (strcat "SetProtocol failed! Return code is " (itoa status) "."))
					;; ELSE
						(write-line "SetProtocol successful!")
					)
				)
				(write-line "ProtocolFlag value must be 1,2,4 or 8.")
			;; ELSE
				
			)
		) 
	)
)



;********************************************************************************************************
; FindFirstUnit	- This function calls sproFindFirstUnit of SPROEVAL.ARX to Get license from key .
; INPUT					- developerID.
; OUTPUT				- nth 0 is the API return code.
; DESCRIPTION		- To call RNBOsproFindFirstUnit API.
;
;********************************************************************************************************
(defun FindFirstUnit ()
	(setq developer_id (getstring "Enter DeveloperID(valid range 0000-FFFF): "))
	(if (= developer_id "" )
		(write-line "Specify developerID to proceed.")
	;else
		(progn
			(readHexData developer_id 4 )
			(if (=  value 0 )
				(write-line "DeveloperID must be in hex with length not exceeding 4 digits.")
				(progn
					(setq result_list (sproFindFirstUnit developer_id ))   ;call the API
					(setq status (nth 0 result_list))
					(if (/= status SP_SUCCESS)
						(write-line (strcat "FindFirstUnit failed! Return code is " (itoa status) "."))
						(write-line "FindFirstUnit successful!")
					)
				)
			)
		)
	)
;)
)

;********************************************************************************************************
; FindNextUnit  - This function calls sproFindNexttUnit of SPROEVAL.ARX to search second key with same DevID. 
; INPUT					- None.
; OUTPUT				- nth 0 is the API return code.
; DESCRIPTION		- To call RnbosproFindNextUnit API.
;********************************************************************************************************
(defun  FindNextUnit ()
	(setq result_list (sproFindNextUnit))
	(setq status (nth 0 result_list))
	(if (/= status SP_SUCCESS)
		(write-line (strcat "FindNextUnit failed! Return code is " (itoa status) "."))
		;; ELSE
		(write-line "FindNextUnit successful!")
	)
)


;********************************************************************************************************
; SetHeartBeat	- This function calls sproSetHeartBeat of SPROEVAL.ARX to Sets license timeout(HeartBeat) value.
; INPUT					- heartBeat-HeartBeat value to be set.
; OUTPUT				- nth 0 is the API return code.
; DESCRIPTION		- To call RnbosproSetHeartBeat API.
;********************************************************************************************************
(defun  SetHeartBeat()
	(setq heartBeat (getstring "Enter HeartBeat value(MIN_HEARTBEAT =60, MAX_HEARTBEAT =2592000, INFINITE_HEARTBEAT=-1) : "))  
	
	(if (= heartBeat "")
		(write-line "Specify heartbeat value to proceed.")
		;; ELSE
		(progn
			(if ( = (atoi heartBeat) -1 )
				( progn
					(setq result_list (sproSetHeartBeat heartBeat))  ; call to API function to establish
					(setq status (nth 0 result_list))
					(if (/= status SP_SUCCESS)
						(write-line (strcat "SetHeartbeat failed! Return code is " (itoa status) "."))
					;; ELSE
						(write-line "SetHeartBeat successful!")
					)
				)
				( progn
					(IsInt heartBeat 7)
					(if (=  intvalue 0 )
						(write-line "Heartbeat value must be an integer between 60 to 2592000. Enter -1 for infinite heartbeat.")
						(progn
							(if (or (< (atoi heartBeat) 60) (> (atoi heartBeat) 2592000))
								(write-line "Heartbeat value must be an integer between 60 to 2592000. Enter -1 for infinite heartbeat.")
								(progn
									(setq result_list (sproSetHeartBeat heartBeat))  ; call to API function to establish
									(setq status (nth 0 result_list))
									(if (/= status SP_SUCCESS)
										(write-line (strcat "SetHeartBeat failed! Return code is " (itoa status) "."))
									;; ELSE
										(write-line "SetHeartBeat successful!")
									)
								)
							)
						)
					)
				)
			)
		)
	)
)


;********************************************************************************************************
; Read					- This function calls sproRead of SPROEVAL.ARX to read cell data from key.
; INPUT					- address : cell address to be read
; OUTPUT				- nth 0 is the API return code and nth 1 is the cell data return.
; DESCRIPTION		- To call RNBOsproRead API. 
;********************************************************************************************************
(defun Read ()
	(setq address (getstring "Enter cell address(valid range 00-3F): "))
	(if (= address "")
		(write-line "Specify cell address to proceed.")
		;; ELSE
		(progn
			(readHexData address 2 )
			(if (=  value 0 )
				(write-line "Cell address must be in hex with length not exceeding 2 digits.")
				(progn
					(setq result_list (sproRead address))
					(setq status  ( nth 0 result_list))
					
					(if (/= status SP_SUCCESS)
						(write-line (strcat "Read failed! Return code is " (itoa status) "."))
						;; ELSE
						(progn
							(setq data  ( nth 1 result_list))
							(write-line ( strcat "Read successful! Data = " data ".")) 
						)
					)
				)
			)
		)
	)
)


;********************************************************************************************************
; ExtendedRead	- This function calls sproExtendedRead of SPROEVAL.ARX to read cell data from key.
; INPUT					- address : cell address to be read
; OUTPUT				- nth 0 is the API return code , nth 1 is the cell data return and nth 2 is the access code of cell data.
; DESCRIPTION		- To call RNBOsproExtendedRead API.
;********************************************************************************************************
(defun ExtendedRead()
	(setq address (getstring "Enter cell address(valid range 00-3F): "))
	(if (= address "")
		(write-line "Specify cell address to proceed.")
		;; ELSE
		(progn
			(readHexData address 2 )
			(if (=  value 0 )
				(write-line "Cell address must be in hex with length not exceeding 2 digits.")
				(progn
					(setq result_list (sproExtendedRead address))       ;call the API
					(setq status (nth 0 result_list))
					(if (/= status SP_SUCCESS)
						(write-line (strcat "ExtendedRead failed! Return code is " (itoa status) "."))
					;; ELSE
						(progn
							(setq data (nth 1 result_list))
							(setq accesscode (nth 2 result_list))
							(write-line ( strcat "ExtendedRead successful! Data = " data "." "  AccessCode = "(itoa accesscode )"."))
						)
					)
				)
			)
		)
	)
)


;********************************************************************************************************
; Write					- This function calls sproWrite of SPROEVAL.ARX to writer cell data on key.
; INPUT					- WritePassword ,write_address,data and access_code .
; OUTPUT				- nth 0 is the API return code.
; DESCRIPTION		- To call RNBOsproWrite API .
;********************************************************************************************************
(defun Write ()
	(setq WritePassword (getstring "Enter write password(valid range 0000-FFFF):")) 
	(setq write_address (getstring "Enter cell address(valid range 00-3F):"))
	(setq data (getstring "Enter data to be written(valid range 0000-FFFF):"))
	(setq access_code (getstring "Enter access code(0=data, 1=locked data, 2=counter, 3=algo):"))
	
	(if (= WritePassword "") 
		(write-line "Specify write password to proceed.")
		(progn
			(if (= write_address "")
				(write-line "Specify cell address to proceed.")
				(progn
					(if (= data "")
						(write-line "Specify data to be written to proceed.")
						(progn
							(if (=  access_code "")
								(write-line "Specify an access code to proceed.")
								(progn
									(readHexData WritePassword 4 )
									(if (=  value 0 )
										(write-line "Write password must be in hex with length not exceeding 4 digits.")
										(progn
											(readHexData write_address 2 )
											(if (=  value 0 )
												(write-line "Cell address must be in hex with length not exceding 2 digits.")
												(progn
													(readHexData data 4 )
													(if (=  value 0 )
														(write-line "Data to be written must be in hex with length not exceeding 4 digits.")
														(progn
																(IsInt access_code 1)
																(if (=  intvalue 0 )															
																				(write-line "Access code must be between 0 to 3(0=data, 1=locked data, 2=counter, 3=algo). ")																	
																				(progn
															(if (/= access_code "0")
															(progn

																	(if (or ( <(atoi access_code) 1) (> (atoi access_code) 3))
																		(write-line "Access code must be between 0 to 3(0=data, 1=locked data, 2=counter, 3=algo). ")
																	;; ELSE
																		(progn					
																			(setq result_list (sproWrite WritePassword write_address data (atoi access_code)))
																			(setq status (nth 0 result_list))
																			(if (/= status SP_SUCCESS)
																				(write-line (strcat "Write failed! Return code is " (itoa status) "."))
																			;; ELSE
																				(write-line "Write successful!")
																			)
																		)
																	)
																)
																(progn
																	(setq result_list (sproWrite WritePassword write_address data (atoi access_code)))
																			(setq status (nth 0 result_list))
																			(if (/= status SP_SUCCESS)
																				(write-line (strcat "Write failed! Return code is " (itoa status) "."))
																			;; ELSE
																				(write-line "Write successful!")
																			)
																		)
																)
														)
													)
													)
													)
												)
											)
										)
									)
								)
							)
						)
					)
				)
			)
		)
	)
			
)


;**************************************************************************
; OverWrite			- This function calls sproOverWrite of SPROEVAL.ARX to Overwriter cell data on key.
; INPUT					- WritePassword, OverWritePassword1, OverWritePassword2, write_address, data and access_code. 
; OUTPUT				- nth 0 is the API return code
; DESCRIPTION		- To call RNBOsproOverWrite API.
;***************************************************************************
(defun Overwrite ()
	(setq WritePassword (getstring "Enter write password(valid range 0000-FFFF):"))
	(setq OverwritePassword1 (getstring "Enter overwrite Password1(valid range 0000-FFFF):"))
	(setq OverwritePassword2 (getstring "Enter overwrite Password2(valid range 0000-FFFF):"))
	(setq overwrite_address (getstring "Enter cell address(valid range 00-3F):"))
	(setq data (getstring "Enter data to be written(valid range 0000-FFFF):"))
	(setq access_code (getstring "Enter access Code(0=data, 1=locked data, 2=counter, 3=algo):"))
	
	(if (= WritePassword "") 
		(write-line "Specify write password to proceed.")
		(progn
			(if (= OverwritePassword1 "") 
				(write-line "Specify overwrite password1 to proceed.")
				(progn
					(if (= OverwritePassword2 "") 
						(write-line "Specify overwrite password2 to proceed.")
						(progn
							(if (= overwrite_address "")
								(write-line "Specify cell address to proceed.")
								(progn
									(if (= data "")
										(write-line "Specify data to be written to proceed.")
										(progn
											(if (=  access_code "")
												(write-line "Specify an access code to proceed.")
												(progn
													(readHexData WritePassword 4 )
													(if (=  value 0 )
														(write-line "Write password must be in hex with length not exceeding 4 digits.")
														(progn
															(readHexData OverwritePassword1 4 )
															(if (=  value 0 )
																(write-line "Overwrite password1 must be in hex with length not exceeding 4 digits.")
																(progn
																	(readHexData OverwritePassword2 4 )
																	(if (=  value 0 )
																		(write-line "Overwrite password2 must be in hex with length not exceeding 4 digits.")
																		(progn
																			(readHexData overwrite_address 2 )
																			(if (=  value 0 )
																				(write-line "Cell address must be in hex with length not exceeding 2 digits.")
																				(progn
																					(readHexData data 4 )
																					(if (=  value 0 )
																						(write-line "Data to be written must be in hex with length not exceeding 4 digits.")
																						(progn
																						(IsInt access_code 1)
																(if (=  intvalue 0 )															
																				(write-line "Access code must be between 0 to 3(0=data, 1=locked data, 2=counter, 3=algo). ")																	
																				(progn
																							(if (/= access_code "0")
																								(progn
																									(if (or ( <(atoi access_code) 1) (> (atoi access_code) 3))
																										(write-line "Access code must be between 0 to 3(0=data, 1=locked data, 2=counter, 3=algo). ")
																									;; ELSE
																										(progn					
																											(setq result_list (sproOverwrite WritePassword OverwritePassword1 OverWritePassword2 overwrite_address data (atoi access_code)))
																											(setq status (nth 0 result_list))
																											(if (/= status SP_SUCCESS)
																												(write-line (strcat "Overwrite failed! Return code is " (itoa status) "."))
																												(write-line "Overwrite successful!")
																											)
																										)
																									)
																								)
																							(progn
																								(setq result_list (sproOverwrite WritePassword OverwritePassword1 OverWritePassword2 overwrite_address data (atoi access_code)))
																								(setq status (nth 0 result_list))
																								(if (/= status SP_SUCCESS)
																									(write-line (strcat "OverWrite failed! Return code is " (itoa status) "."))
																								;; ELSE
																									(write-line "Overwrite successful!")
																								)
																							)
																						)
																						)
																						)
																						)
																					)
																				)
																			)
																		)
																	)
																)
															)
														)
													)
												)
											)
										)
									)
								)
							)
						)
					)
				)
			)
		)
	)
) 


;********************************************************************************************************
; Decrement    	- This function calls sproOverWrite of SPROEVAL.ARX to decrement counter data written on key. 
; INPUT					- WritePassword  and dec_address.
; OUTPUT				- nth 0 is the API return code.
; DESCRIPTION		- To call RNBOsproDecrement API. 
;********************************************************************************************************
(defun Decrement()
	(setq WritePassword (getstring "Enter write password(valid range 0000-FFFF):")) 
	(setq dec_address (getstring "Enter cell address(valid range 00-3F):"))
	(if (= WritePassword "") 
		(write-line "Specify write password to proceed.")
		(progn
			(if (= dec_address "")
				(write-line "Specify cell address to proceed.")
				(progn
					(readHexData WritePassword 4 )
					(if (=  value 0 )
						(write-line "Write password must be in hex with length not exceeding 4 digits.")
						(progn
							(readHexData dec_address 2 )
							(if (=  value 0 )
								(write-line "Cell address must be in hex with length not exceeding 2 digits.")
								(progn
									(setq result_list (sproDecrement WritePassword dec_address))
									(setq status (nth 0 result_list))             ;function
									(if (/= status SP_SUCCESS)
										(write-line (strcat "Decrement failed! Return code is " (itoa status) "."))
									;; ELSE
										(write-line "Decrement successful!")
									)
								)
							)
						)
					)
				)
			)
		)
	)
)


;********************************************************************************************************
; Query					- This function calls sproQuery of SPROEVAL.ARX to query on cell data. 
; INPUT					- address and query_string.
; OUTPUT				- nth 0 is the API return code and nth 1 is the qyery response from key cell.
; DESCRIPTION		- To call RNBOsproQuery API. 
;********************************************************************************************************
(defun Query ()
	(setq address (getstring "Enter cell address(valid range 00-3F):"))
	(setq query_string (getstring "Enter query-string (MIN-LENGTH=8 and MAX-LENGTH=112):"))
	(if (= address "") 
		(write-line "Specify cell address to proceed.")
		(progn
			(if (= query_string "")
				(write-line "Specify query-string to proceed.")
				(progn
					(readHexData address 2 )
					(if (=  value 0 )
						(write-line "Cell address must be in hex with length not exceeding 2 digits.")
						(progn
							(readHexData query_string 112 )
							(if (=  value 0 )
								(write-line "Query data must be in hex. The length of data must be even and between 8 to 112.")
								(progn
									(setq length (strlen query_string))
									(if (or (/= 0 (rem length 2)) ( < length 8) )
									(write-line "Query data must be in hex. The length of data must be even and between 8 to 112.")
									;; ELSE
										(progn
											(setq result_list (sproQuery address query_string))
											(setq status (nth 0 result_list))
											(if (/= status SP_SUCCESS)
												(write-line (strcat "Query failed! Return code is " (itoa status) "."))
											;; ELSE
												(progn
													(setq qResponse (nth 1 result_list))				   
													(write-line ( strcat "Query successful! Query Response = " qResponse))
												)
											)
										)
									)
								)
							)
						)
					)
				)
			)
		)
	)
)

;********************************************************************************************************
; Activate			- This function calls sproActivate of SPROEVAL.ARX to activate algo on key. 
; INPUT					- WritePassword, activate_passwd1, activate_passwd2 and activate_address
; OUTPUT				- nth 0 is the API return code.
; DESCRIPTION		- To call RNBOsproActivate API.
;********************************************************************************************************
(defun Activate ()
	(setq WritePassword (getstring "Enter Write Password(valid range 0000-FFFF):"))
	(setq activate_passwd1 (getstring "Enter Activate Password1(valid range 0000-FFFF):"))
	(setq activate_passwd2 (getstring "Enter Activate Password2(valid range 0000-FFFF):"))
	(setq activate_address (getstring "Enter cell address(valid range 00-3F):"))
	(if (= WritePassword "") 
		(write-line "Specify write password to proceed.")
		(progn
			(if (= activate_passwd1 "") 
				(write-line "Specify activate password1 to proceed.")
				(progn
					(if (= activate_passwd2 "") 
						(write-line "Specify activate password2 to proceed.")
						(progn
							(if (= activate_address "")
								(write-line "Specify cell address to proceed.")
								(progn
									(readHexData WritePassword 4 )
									(if (=  value 0 )
										(write-line "Write password must be in hex with length not exceeding 4 digits.")
										(progn
											(readHexData activate_passwd1 4 )
											(if (=  value 0 )
												(write-line "Activate password1 must be in hex with length not exceeding 4 digits.")
												(progn
													(readHexData activate_passwd2 4 )
													(if (=  value 0 )
														(write-line "Activate password2 must be in hex with length not exceeding 4 digits.")
														(progn
															(readHexData activate_address 2 )
															(if (=  value 0 )
																(write-line "Cell address must be hex with length not exceeding 2 digits.")
																(progn
																	(setq result_list (sproActivate WritePassword activate_passwd1
																											activate_passwd2 activate_address))
																	(setq status (nth 0 result_list))
																	(if (/= status SP_SUCCESS)
																		(write-line (strcat "Activate failed! Return code is " (itoa status) "."))
																		;; ELSE
																		(write-line "Activate successful!")
																	)
																)
															)
														)
													)
												)
											)
										)
									)
								)
							)
						)
					)
				)
			)
		)
	)
)

;********************************************************************************************************
; ReleaseLicense- This function calls sproReleaseLicense of SPROEVAL.ARX to release all license 
;								- and sublicense issued.
; INPUT					- address and nolic
; OUTPUT				- nth 0 is the API return code and nth 1 is the number of license released from key.
; DESCRIPTION		- To call RNBOsproReleaseLicense API.
;********************************************************************************************************
(defun  ReleaseLicense()
	(setq address (getstring "Enter cell address(valid range 00-3F):"))  
	(setq nolic (getstring "Enter NumLic to release(valid range 0 to 65535):"))
	(if (= address "")
		(write-line "Specify cell address to proceed.")
		;; ELSE
		(progn
			(if (= nolic "")
				(write-line "Specify number of license to release to proceed.")
			;; ELSE
				(progn
					(readHexData address 2 )
					(if (=  value 0 )
						(write-line "Cell address must be in hex with length not exceeding 2 digits.")
						(progn
																(IsInt nolic 5)
																(if (=  intvalue 0 )															
																
																								(write-line "nnNumber of sublicense to release must be an integer between 0 to 65535.")
							(progn

							(if (or(< (atoi nolic) 0) (> (atoi nolic) 65535))
								(write-line "Number of sublicense to release must be an integer between 0 to 65535.")
							;; ELSE
								(progn
									(setq result_list (sproReleaseLicense address nolic ))  ; call to API function to establish
									(setq status (nth 0 result_list))
									(if (/= status SP_SUCCESS)
										(write-line (strcat "ReleaseLicense failed! Return code is " (itoa status) "."))
									;; ELSE
										(if (or (= address "0") (= (atoi address) 0))
											(write-line "ReleaseLicense successful! All issued license released. ")
											;; ELSE
											(progn 
												(setq licReleased (nth 1 result_list))
												(write-line ( strcat "ReleaseLicense successful!" (itoa licReleased ) "license released. "))
											)
										)
									)
								)
							)
							)
							)
						)
					)
				)
			)
		)
	)
)


;********************************************************************************************************
; GetSubLicense	- This function calls sproGetSubLicense of SPROEVAL.ARX to issue sublicense from key.
; INPUT					- address
; OUTPUT				- nth 0 is the API return code.
; DESCRIPTION		- To call RNBOsproGetSubLIcense API.
;********************************************************************************************************
(defun  GetSubLicense()
	(setq address (getstring "Enter cell address(valid range 00-3F):"))  
	(if (= address "")
		(write-line "Specify cell address to proceed.")
		;; ELSE
		(progn
			(readHexData address 2 )
			(if (=  value 0 )
				(write-line "Cell address must be in hex with length not exceeding 2 digits.")
				(progn
					(setq result_list (sproGetSubLicense address))  ; call to API function to establish
					(setq status (nth 0 result_list))
					(if (/= status SP_SUCCESS)
						(write-line (strcat "GetSubLicense failed! Return code is " (itoa status) "."))
					;; ELSE
						(write-line "GetSubLicense successful!")
					)
				)
			)
		)
	)
)



;********************************************************************************************************
; EnumServer		- This function calls sproGetSubLicense of SPROEVAL.ARX to issue sublicense from key.
; INPUT					- eFlag(NSPRO_RET_ON_FIRST=1,NSPRO_GET_ALL_SERVERS=2,NSPRO_RET_ON_FIRST_AVAILABLE=4), 
;								- devID and numServer. 
; OUTPUT				- nth 0 is the API return code, nth 1 is the numserver and rest is server and licavai
;								- (depending upon numServer)
; DESCRIPTION		- To call RNBOsproEnumServer API.
;********************************************************************************************************
(defun  EnumServer()
	(write-line "Enter EnumFlag ")
	(setq eFlag (getstring "(RET_ON_FIRST=1,GET_ALL_SERVERS=2,RET_ON_FIRST_AVAILABLE=4):"))  
	(setq devID (getstring "Enter DeveloperID(valid range 0000-FFFF):"))  
	(setq numServer (getstring "Enter no. of servers(Min=1 and Max=10):"))  
	( if (= eFlag "" )
		(write-line "specify enumflag value to proceed.")
	;; ELSE
		(progn     
			(if (= devID "" )
				(write-line "Specify developerID to proceed.")
			;else
				(progn
					(if (=  numServer "")
						(write-line "Specify a no. of servers value to proceed.")		
						(progn	
							(if (not(or (= eFlag "1") (= eFlag "2")(= eFlag "4")))
								(write-line "EnumFlag value must be 1,2 or 4.")
							;; ELSE
								(progn
									(readHexData devID 4 )
									(if (=  value 0 )
										(write-line "DeveloperID must be in hex with length not exceeding 4 digits.")
										(progn
											(if (or(< (atoi numServer) 1) (> (atoi numServer) 10))
												(write-line "No. of servers value must be between 1 to 10.")
											;; ELSE
												(progn	
													(setq result_list  (sproEnumServer eFlag devID numServer)) ; call to API function to establish
													(setq status (nth 0 result_list))	
													
													(if (/= status SP_SUCCESS)
														(write-line (strcat "EnumServer failed! Return code is " (itoa status) "."))
														(progn
														(setq totalServer (nth 1 result_list))
														(write-line ( strcat "EnumServer successful ! Total Server Return = " (itoa totalServer)))
														(if (>= totalserver 1 )
															(progn
															(write-line ( strcat "Server= " (nth 2 result_list) " and LicAvailable= " (itoa (nth 3 result_list)) ))
															(if (>= totalserver 2 )
																(progn
																(write-line ( strcat "Server= " (nth 4 result_list) " and LicAvailable= " (itoa (nth 5 result_list)) ))
																(if (>= totalserver 3 )
																	(progn
																	(write-line ( strcat "Server= " (nth 6 result_list) " and LicAvailable= " (itoa (nth 7 result_list)) ))			
																	(if (>= totalserver 4 )
																		(progn
																		(write-line ( strcat "Server= " (nth 8 result_list) " and LicAvailable= " (itoa (nth 9 result_list)) ))
																		(if (>= totalserver 5 )
																			(progn
																			(write-line ( strcat "Server= " (nth 10 result_list) " and LicAvailable= " (itoa (nth 11 result_list)) )) 
																			(if (>= totalserver 6 )
																				(progn
																				(write-line ( strcat "Server= " (nth 12 result_list) " and LicAvailable= " (itoa (nth 13 result_list)) ))
																				(if (>= totalserver 7 )
																					(progn
																					(write-line ( strcat "Server= " (nth 14 result_list) " and LicAvailable= " (itoa (nth 15 result_list)) ))					
																					(if (>= totalserver 8 )
																						(progn
																						(write-line ( strcat "Server= " (nth 16 result_list) " and LicAvailable= " (itoa (nth 17 result_list)) ))							
																						(if (>= totalserver 9 )
																							(progn
																							(write-line ( strcat "Server= " (nth 18 result_list) " and LicAvailable= " (itoa (nth 19 result_list)) ))								
																							(if (>= totalserver 10 )
																								(progn
																								(write-line ( strcat "Server= " (nth 20 result_list) " and LicAvailable= " (itoa (nth 21 result_list)) ))								
																								)
																							)
																							)
																						)
																						)
																					)
																					)
																				)
																				)
																			)
																			)
																		)
																		)		
																	)
																	)
																)
																)
															)
															)
														)
														)
													)
												)
											)
										)
									)
								)
							)	
						)
					)
				)
			)					
		)
	)
)										
											
										


;********************************************************************************************************
; GetFullStatus	- This function calls sproGetFullStatus of SPROEVAL.ARX to get last error code return.
; INPUT			- none
; OUTPUT		- nth 0 is the last API return code
; DESCRIPTION	- To call RNBOsproGetFullStatus API.
;********************************************************************************************************
(defun GetFullStatus ()
	(setq result_list (sproGetFullStatus))
	(setq Fullstatus (nth 0 result_list))
	(write-line (strcat "GetFullStatus successful!"))
	(write-line (strcat "Status of last API called is " (itoa Fullstatus) "."))
)



;********************************************************************************************************
; GetHardLimit	- This function calls sproGetHardLimit of SPROEVAL.ARX to get HardLimit of the license issued key.
; INPUT			- None
; OUTPUT		- nth 0 is the API return code and nth 1 is the Hardlimit of key.
; DESCRIPTION	- To call RNBOsproGetHardLimit API.
;********************************************************************************************************
(defun  GetHardLimit()
	(setq result_list (sproGetHardLimit))  ; call to API function to establish
	(setq status (nth 0 result_list))
	(setq hardlimit (nth 1 result_list))
	(if (/= status SP_SUCCESS)
		(write-line (strcat "GetHardLimit failed! Return code is " (itoa status) "."))
		;; ELSE
		(write-line ( strcat "GetHardLimit successful! HardLimit= " (itoa hardlimit)"."))
	)
)


;********************************************************************************************************
; GetKeyInfo	- This function calls sproGetKeyInfo SPROEVAL.ARX to keyInfo of all key attached.
; INPUT		- keyid
; OUTPUT	- nth 0 is the API return code , nth 1 is devid of key,nth 2 is the hardlimit of the key,
;		- nth 3 is the license in use ,nth 4 is the licensetimedout and nth 5 is lichighestuse.
; DESCRIPTION	- To call RNBOsproGetKeyInfo API.
;***************************************************************************
(defun  GetKeyInfo()
	;(setq keyindex "1" )
	(setq keyid (getstring "Enter DeveloperID(valid range 0000-FFFF):"))  
	(setq keyindex (getstring "Enter KeyIndex(valid range 1-10):"))  
	(if (= keyid "" )
		(write-line "Specify developerID to proceed.")
	;else
		(progn
			(if (=  keyindex "")
				(write-line "Specify a keyIndex value to proceed.")		
				(progn
					(readHexData keyid 4 )
					(if (=  value 0 )
						(write-line "DeveloperID must be in hex with length not exceeding 4 digits.")
						(progn
							(IsInt keyindex 2)
							(if (=  intvalue 0 )
								(write-line "KeyIndex must be between 1 to 10.")
								(progn
								
									(if (or(< (atoi keyindex) 1) (> (atoi keyindex) 10))
										(write-line "KeyIndex must be between 1 to 10.")
									;; ELSE
										(progn
											(setq result_list (sproGetKeyInfo keyid keyIndex))  ; call to API function to establish
											(setq status (nth 0 result_list))
											(if (/= status SP_SUCCESS)
												(write-line (strcat "GetKeyInfo failed! Return code is " (itoa status) "."))
											;; ELSE
												(progn
													(write-line "GetKeyInfo successful!")
													(setq devid (nth 1 result_list))
													(setq hardlimit (nth 2 result_list))
													(setq licuse (nth 3 result_list))
													(setq lictimeout (nth 4 result_list))
													(setq highuse (nth 5 result_list))
													(write-line ( strcat "DevID= "  devid))
													(write-line ( strcat "HardLimit= " (itoa hardlimit)))
													(write-line ( strcat "License in Use= " (itoa licuse)))
													(write-line ( strcat "License Timed Out= " (itoa lictimeout)))
													(write-line ( strcat "Highest Use= " (itoa highuse)))
												)
											
											)
										)
									)
								)
							)
						)
					)
				)
			)	
		)	
	)				
)					
		


;********************************************************************************************************
; GetVersion	- This function calls sproGetVersion SPROEVAL.ARX to get driver version.
; INPUT		- None
; OUTPUT	- nth 0 is the API return code , nth 1 is Min Versiondevid, nth 2 is the Maj Version,
;		      - nth 3 is the Revision Number in use and nth 4 is the OS Driver Type.
; DESCRIPTION	- To call RNBOsproGetVersion API.
;********************************************************************************************************

(defun Getversion ()
	(setq result_list (sproGetVersion))
	(setq status (nth 0 result_list))
	(if (/= status SP_SUCCESS)
		(write-line (strcat "GetVersion failed! Return code is " (itoa status) "."))
		;; ELSE
		(progn
			(write-line "GetVersion successful!")
			(write-line (strcat "Major Version: " (itoa (nth 1 result_list))))
			(write-line (strcat "Minor Version:"(itoa(nth 2 result_list))))	
			(write-line (strcat "Revision:"(itoa (nth 3 result_list))))
			(write-line (strcat "OS Driver Type: " (nth 4 result_list)))
		)
	)
)



;********************************************************************************************************
; SetContactServer - This function calls sproSetContactServer SPROEVAL.ARX to set contact server for communication.
; INPUT		   - srvr : ContactServer name
; OUTPUT	   - nth 0 is the API return code
; DESCRIPTION	   - To call RNBOsproSetContactServer API.
;********************************************************************************************************
(defun  SetContactServer()
	(setq srvr (getstring "Enter ContactServer Name: "))  
	(if (= srvr "" )
		(write-line "Specify ContaceServer name to proceed.")
		(progn
			(if (> (strlen srvr) 63 )
				(write-line "ContactServer name  length must not be exceeded 63.")
				(progn
					(setq result_list (sproSetContactServer srvr ))  ; call to API function to establish
					(setq status (nth 0 result_list))
					(if (/= status SP_SUCCESS)
						(write-line (strcat "SetContactServer failed! Return code is " (itoa status) "."))
					;; ELSE
						(write-line (strcat "SetContactServer successful!"))
					)
				)
			)
		)
	)
)


;********************************************************************************************************
; GetContactServer	- This function calls sproGetContactServer SPROEVAL.ARX to get Contact Server name.
; INPUT			- None
; OUTPUT		- nth 0 is the API return code and nth 1 is the Contact Server name returned.
; DESCRIPTION		- To call RNBOsproGetContactServer
;********************************************************************************************************
(defun  GetContactServer()
	(setq result_list (sproGetContactServer))  ; call to API function to establish
	(setq status (nth 0 result_list))
	(if (/= status SP_SUCCESS)
		(write-line (strcat "GetContactServer failed! Return code is " (itoa status) "."))
				;; ELSE
		(progn
			(setq server (nth 1 result_list) )
			(write-line (strcat "GetContactServer successful! ServerName = " server ))
		)
	)
)


;********************************************************************************************************
; SuperProKeyView	- Display infomation and key cell contents on screen for user. 
; INPUT			- None
; OUTPUT		- None
; DESCRIPTION		- This is lisp local function and internaly call sproExtendedRead function of 
;			- ARX to display key view.
;********************************************************************************************************
(defun KeyView ()
	(setq line_1 horz)
	(setq line horz)
	(repeat 12
		(setq line (strcat line_1 line))
	)
	(setq b_1 (strcat (chr 43) line (chr 43)))
	(setq b_2 (strcat  line (chr 43)))
	(setq b_3 (strcat  line (chr 43)))
	(setq bottom_line (strcat b_1 b_2 b_2 b_3))
	(setq line_1 horz)
	(setq line horz)
	(repeat 12
		(setq line (strcat line_1 line))
	)
	(setq t_1 (strcat (chr 43) line (chr 43)))
	(setq t_2 (strcat  line (chr 43)))
	(setq t_3 (strcat  line (chr 43)))
	(setq top_1 (strcat t_1 t_2 t_2 t_3))
	(setq line_1 horz)
	(setq line horz)
	(repeat 12
		(setq line (strcat line_1 line))
	)
	(setq t_1 (strcat (chr 43) line (chr 43)))
	(setq t_2 (strcat  line (chr 43)))
	(setq t_3 (strcat  line (chr 43)))
	(setq top_2 (strcat t_1 t_2 t_2 t_3))
	(write-line top_1)
	(setq head (strcat vert
							" Adr Data AC " vert
							" Adr Data AC " vert
							" Adr Data AC " vert
							" Adr Data AC " vert))
	(write-line head)
	(write-line top_2)
	(setq a 48)
	(repeat 16
		(setq b 48)
		(setq data_list (list nil))
		(setq ac_list (list nil))
		(setq adr_list (list nil))
		(repeat 4
			(if (= a 58)
				(setq a 65)
			)
			(setq adr (strcat (chr b) (chr a)))
			(setq adr_list (cons adr adr_list))
			(setq result_list (sproExtendedRead adr))
			(if (/= (nth 0 result_list) SP_SUCCESS)
				(progn
					(setq data_list (cons "????" data_list))
					(if (= (nth 0 result_list) SP_ACCESS_DENIED)
						(setq ac_list (cons "3" ac_list))
								;; ELSE
						(setq ac_list (cons "?" ac_list))
					)
				)
				;; ELSE
				(progn
					(setq data_list (cons (nth 1 result_list) data_list))
					(setq ac_list (cons (itoa (nth 2 result_list)) ac_list))
				)
			)
			(setq b (1+ b))
		)
		(setq pr_string (strcat vert  " "
		(nth 3 adr_list)  ": "
		(nth 3 data_list) "  "
		(nth 3 ac_list)   " " vert " "
		(nth 2 adr_list)   ": "
		(nth 2 data_list)  "  "
		(nth 2 ac_list)    " " vert " "
		(nth 1 adr_list)    ": "
		(nth 1 data_list)   "  "
		(nth 1 ac_list)     " " vert " "
		(nth 0 adr_list)     ": "
		(nth 0 data_list)    "  "
		(nth 0 ac_list)  " " vert )
	)
	(write-line pr_string)
	(setq a (1+ a))
	)
	(write-line bottom_line)
)
;********************************************************************************************************
; Exit		- Close application.
; INPUT		- None
; OUTPU		- None
; DESCRIPTION	- It will call sproReleaseLicense function to release all issued license and then terminate application
;********************************************************************************************************
(defun  Exit()
	(write-line "Quiting....")
	(setq reladd "0" ) 
	(setq norel "0" ) 
	(setq result_list (sproReleaseLicense "0" "0" ))
	(write-line "Application normally terminated")
	(setq badcommand "Exit")
)


;********************************************************************************************************
;sproeval 	- Main Program 
; INPUT		- None
; OUTPU		- None
; DESCRIPTION	- Display information on AutoCAD command prompt and display seperate prompt for user to enter command
;********************************************************************************************************
(defun sproeval ()
	(textpage)
	(setq command_list (list "C" "E" "B" "A"  "K" "L" "Z" "T"  "V" "R" "X" "D" "W" "O" "A"
													 "Q" "P" "F" "N" "V" "U" "E" "G" "H" "M" "S" "Y" "Z" ))
	(write-line "*****************************************************************************")
	(write-line "Sentinel SuperPro Evaluation Program.")
	(write-line "Copyright (c) 1995-2002, Rainbow Technologies Inc. All rights reserved.")	
	(write-line "*****************************************************************************")
	(terpri)
	(write-line "This program is intended to allow a basic level of interaction with a Rainbow")
	(write-line "Sentinel SuperPro hardware key and driver. To use this program, you must know ")
	(write-line "the Developer ID of your SuperPro key and associated passwords. ")
	(terpri)	
	(write-line "SuperPro API's and corresponding commands to call these APIs are : ")
	(terpri)
	(write-line "FormatP)acket    Initializ)e        SetProt)ocol        SetC)ontactServer") 
	(write-line "F)indFirstUnit   FindN)extUnit      G)etContactServer   SetH)eartBeat ")
	(write-line "R)ead            Ex)tendedRead      W)rite              O)verwrite") 
	(write-line "Q)uery           A)ctivate          D)ecrement          GetV)ersion")
	(write-line "GetHardLim)it    GetFu)llStatus     GetK)eyInfo         GetSub)License") 
	(write-line "ReleaseL)icense  EnumS)erver        Key)View            E)xit         ")
	(terpri)
	(write-line "NOTE - All data must be entered as Hexadecimal digits using 0-9,A-F.")
	(terpri)
	(setq result_list (sproFormatPacket))
	(setq status (nth 0 result_list))
	(if (/= status SP_SUCCESS)
		(progn
			(write-line (strcat "FormatPacket failed! Return code is " (itoa status) "."))
			(quit)
		)
			;; ELSE
		(write-line "FormatPacket successful!")
	)	
	(terpri)
	(setq badcommand 0)
	(while (/= badcommand "Exit")
		(setq c (getstring "> "))
		(terpri)	
		(write-line "SuperPro API's and corresponding commands to call these APIs are : ")
		(terpri)
  (write-line "FormatP)acket    Initializ)e        SetProt)ocol        SetC)ontactServer") 
	(write-line "F)indFirstUnit   FindN)extUnit      G)etContactServer   SetH)eartBeat ")
	(write-line "R)ead            Ex)tendedRead      W)rite              O)verwrite") 
	(write-line "Q)uery           A)ctivate          D)ecrement          GetV)ersion")
	(write-line "GetHardLim)it    GetFu)llStatus     GetK)eyInfo         GetSub)License") 
	(write-line "ReleaseL)icense  EnumS)erver        Key)View            E)xit         ")
		(terpri)
		(setq c (strcase c))
		(if (/= nil (member c command_list))
			(cond
				((= c "K") (GetKeyInfo))	
				((= c "T") (SetProtocol))
				((= c "H") (SetHeartBeat))
				((= c "G") (GetContactServer))
				((= c "C") (SetContactServer))
				((= c "L") (ReleaseLicense))
				((= c "P") (FormatPacket))
				((= c "B") (GetSubLIcense))
				((= c "M") (GetHardLimit))
				((= c "S") (EnumServer))
				((= c "Z") (Initialize))
				((= c "R") (Read))
				((= c "X") (ExtendedRead))
				((= c "D") (Decrement))
				((= c "W") (Write))
				((= c "O") (Overwrite))
				((= c "A") (Activate))
				((= c "Q") (Query))
				((= c "F") (FindFirstUnit))
				((= c "N") (FindNextUnit))
				((= c "V") (Getversion))
				((= c "U") (GetFullStatus))
				((= c "Y") (KeyView))
				((= c "E") (Exit))
				(t (illegal))
			)
		)
	)
)
